#include <iostream>
#include <fstream>
#include <vector>

using std::ifstream;
using std::ofstream;
using std::cout;

#include "events.hh"
#include "playerdata.hh"
#include "stringfun.hh"
#include "taskmanager.hh"

static const char passwdchars[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 ";

playerdata::~playerdata()
{
	if(save_ok)
	{
		taskmanager += informevent(name, "goes link dead", owner.sock);
		save();
	}
}

void playerdata::colour(int newattr) const
{
	if(newattr == -1)
	{
		attr = newattr;
		return;
	}
	if(newattr == attr || !COLOURS)return;
	
	bool braindead = false;
	
	if(attr == -1)braindead = true;
	
	std::string Buf;
	if(BROKEN_TERM || newattr != 7 || braindead)
	{
		static const char Swap[] = "04261537";
		bool pp = false;
		#define P(a)    do{if(pp)Buf+=';';pp=true;Buf+=a;}while(0)
		#define P2(a,b) do{if(pp)Buf+=';';pp=true;Buf+=a;Buf+=b;}while(0)
		if(SUPPORT_2x && !braindead)
		{
			if((attr & 0x88) && !(newattr & 0x88)) P('0');
			else if((attr & 0x80) && !(newattr & 0x80)) P("25");
			else if((attr & 0x08) && !(newattr & 0x08)) P("21");
			else if((newattr & 0x80) && !(attr & 0x80)) P('5');
			else if((newattr & 0x08) && !(attr & 0x08)) P('1');
		}
		else
		{
			if(((attr & 0x80) && !(newattr & 0x80))
			|| ((attr & 0x08) && !(newattr & 0x08))
			|| braindead)
			{
				P("0");
				attr = BROKEN_TERM ? (attr&0x77) ^ 0x77 : 7;
			}
			if((newattr & 0x80) && !(attr & 0x80)) P('5');
			if((newattr & 0x08) && !(attr & 0x08)) P('1');
		}
		if(braindead || (newattr & 0x70) != (attr & 0x70)) P2('4', Swap[(newattr>>4)&7]);
		if(braindead || (newattr & 0x07) != (attr & 0x07)) P2('3', Swap[newattr&7]);
		#undef P
	}
	if(Buf == "0")Buf = "";
	Buf += 'm';
	attr = newattr;
	owner.echo("\33[" + Buf, false);
}

void playerdata::load(const std::string &whom)
{
	ifstream f(playerfilename(whom).c_str());
	if(f.good())
	{
		std::string line;
		while(f.good())
		{
			getline(f, line);
			std::vector<std::string> args;
			std::string tmp = strtoupper(argsplit(args, line));
			if(tmp == "SITUATION")
			{
				situation = (enum situation)strtol(argsplit(args, line).c_str(), NULL, 10);
				continue;
			}
			if(tmp == "CREATION")
			{
				creation = (time_t)strtol(argsplit(args, line).c_str(), NULL, 10);
				continue;
			}
			if(tmp == "PROMPT")  { prompt = line; continue; }
			if(tmp == "PASS")    { pass   = line; continue; }
		}
	}
	else
	{
		situation = S_CREATE;
		litecho("\n`FYou do not exist. `7Make a password for you, and we will fix it.\n");
		
		owner.setprompt("Here, please: ", 8, false, passwdchars);
	}
}

void playerdata::save()
{
	if(save_ok)
	{
		owner.echo("Autosave");
		ofstream f(playerfilename().c_str());
		f << "SITUATION " << (int)situation << "\n"
		     "PROMPT " << prompt << "\n"
		     "PASS " << pass << "\n"
		     "CREATION " << creation << "\n"
		;
	}
}

void playerdata::litecho(const std::string &s) const
{
	const char *q = s.c_str();
	const char *p;
	
	for(;;)
	{
		const char *d = q;
	retest:
		p = strchr(d, '`');
		if(!p)
		{
			owner.echo(q, false);
			return;
		}
		owner.echo(std::string(q, 0, p-q), false);
		if(!p[1])break;
		if(p[1] == '`')
			owner.echo("`", false);
		else if((p[1] >= '0' && p[1] <= '9'))
			colour(p[1]-'0');
		else if((p[1] >= 'A' && p[1] <= 'F'))
			colour(p[1]-'A'+10);
		else
		{
			d = p+1;
			goto retest;
		}
		q = p + 2;
	}
}

void playerdata::byebye(const std::string &reason)
{
	cout << "[-" << owner.sock << "]: " << reason << "\n";
	litecho("\r\n\n`C " + reason + "`7 Byebye.\r\n\n");
	owner.shut();
	save();
	save_ok = false;
}

void playerdata::takecareof(const event &ev)
{
	unsigned char saveattr = attr;
	switch(ev.what())
	{
		case E_GLOBAL:
			owner.echo(ev.getsdata(""));
			break;
		case E_INFORM:
		{
			const std::string &n = ev.getsdata("name");
			if(n == name)
			{
				int sk = ev.getidata("sock");
				if(sk != owner.sock)
				{
					cout << owner.sock << " != " << sk << "\n";
					byebye("Collision.");
					return;
				}
			}
			else
			{
				litecho("`EInfo: `F" + n + "`E " + ev.getsdata("msg") + "\n");
			}
			break;
		}
		default:
			;
	}
	colour(saveattr);
}

void playerdata::handleinput()
{
	std::vector<std::string> args;
	std::string input = owner.input;
	owner.input = "";
	
	switch(situation)
	{
		case S_LOGIN:
			name = strtolower(argsplit(args, input));
			if(name.size() < 3)
			{
				byebye("Too short.");
				return;
			}
			load();
			if(situation != S_CREATE)
			{
				situation = S_LOGINPASS;
        		owner.setprompt("Password: ", 8, false, passwdchars);
			}
			break;
		case S_CREATE:
			pass = argsplit(args, input);
			if(pass.size() < 3)
			{
				byebye("Too short.");
				return;
			}
      		owner.setprompt("Repeat: ", 8, false, passwdchars);
			situation = S_PASSCHECK;
			break;
		case S_PASSCHECK:
		{
			std::string s = argsplit(args, input);
			if(s != pass)
			{
				byebye("Mismatch.");
				return;
			}
			
			litecho(
				"\n"
				"`FYou now exist.\n\n");
		
			creation = time(NULL);
			
			load("_");
			save();
			displayprompt();
			
			taskmanager += informevent(name, "has been created", owner.sock);
			
			break;
		}				
		case S_LOGINPASS:
		{
			std::string s = argsplit(args, input);
			if(s != pass)
			{
				byebye("Mismatch.");
				return;
			}
			litecho("\n\n");
			load();
			displayprompt();
			
			taskmanager += informevent(name, "enters the game", owner.sock);
			// Load again, could have been a collision
			// and in that case the event causes saving.
			load();
			
			break;
		}
		default:
			displayprompt();
	}
}
