#include <sys/socket.h>
#include <unistd.h>
#include <sys/stat.h>
#include <cerrno>
#include <poll.h>
#include <iostream>

using std::cout;

#include "servertask.hh"
#include "taskmanager.hh"
#include "playertask.hh"

servertask::servertask(int Port)
{
    int dummy;
    
    if((Plug = socket(AF_INET, SOCK_STREAM, 0)) < 0)
        _exit(EXIT_FAILURE);

ReBind:
    MyAddr.sin_port = htons(Port);              /* network order */
    MyAddr.sin_family = AF_INET;                /* host byte order */
    MyAddr.sin_addr.s_addr = htonl(INADDR_ANY); /* auto-fill with my IP, network long  */
    memset((void *)&(MyAddr.sin_zero), 0, 8);   /* zero the rest of the struct */

    setsockopt(Plug, SOL_SOCKET, SO_REUSEADDR, &dummy, sizeof dummy);
    if(bind(Plug, (struct sockaddr *)&MyAddr, sizeof(struct sockaddr)))
    {
        if(errno == EADDRINUSE) /* Address already in use */
        {
            cout << "Bind failed... retrying.\n";
            sleep(1);
            goto ReBind;
        }
        _exit(EXIT_FAILURE);
    }

    /* Plug will listen. Number of max waiting connections = 10 */

    if(listen(Plug, 10) < 0)
        _exit(EXIT_FAILURE);

    /* Prepare this for accept() - not modified inside the loop */
    AddrLen = sizeof(They);
    
    cout << "Listening for connections on port " << Port << ".\n";
}

servertask::~servertask()
{
}

bool servertask::tick()
{
    return true;
}

unsigned servertask::numpolls() const
{
    return 1;
}

void servertask::writepolls(struct pollfd *arr)
{
    arr[0].fd = Plug;
    arr[0].events = POLLIN;
}

void servertask::checkpolls(const struct pollfd *arr)
{
    if(arr[0].revents & POLLIN)
    {
        int Sock = accept(Plug, (struct sockaddr *)&They, &AddrLen);
        
        if(Sock >= 0)
        {
            taskmanager.insert(new playertask(Sock));
        }
    }
}
